/***************************************************************************
                          cdconsole.cpp  -  description
                             -------------------
    begin                : Sat Feb 24 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cdconsole.h"

CDConsole::CDConsole()
{
	if (!SDL_CDNumDrives()) /* no hay lectoras !! */
	{
		Gra_Debug("CDConsole", "Constructor", "No hay lectora de CD disponible", WARNING);
		estado = NOCD;
		return;
	}
	cdrom = SDL_CDOpen(0);
	if (!cdrom)
	{
		Gra_Debug("CDConsole", "Constructor FAIL", SDL_GetError(), WARNING);
		estado = NOCD;
		return;
	}
	estado = STOP;
	Gra_Debug("CDConsole", "Constructor DONE", SDL_CDName(0), COMENTARIO);
	switch (SDL_CDStatus(cdrom))
	{
		case (CD_TRAYEMPTY):
			Gra_Debug("CDConsole", "Estado", "La bandeja esta vacia", COMENTARIO);
		break;
		case (CD_STOPPED):
			Gra_Debug("CDConsole", "Estado", "Parado", COMENTARIO);
		break;
		case (CD_PLAYING):
			Gra_Debug("CDConsole", "Estado", "Reproduciendo", COMENTARIO);
		break;
		case (CD_PAUSED):
			Gra_Debug("CDConsole", "Estado", "En pausa", COMENTARIO);
		break;
		case (CD_ERROR):
			Gra_Debug("CDConsole", "Estado", "CD Error", COMENTARIO);
		break;
	}
}

CDConsole::~CDConsole()
{
	SDL_CDClose(cdrom);
}

void CDConsole::Play(int track)
{
	if ((estado == STOP) && (CD_INDRIVE(cdrom)))
	{
		estado = PLAY;
		if (SDL_CDPlayTracks(cdrom, track, 0, 1, 0))
			Gra_Debug("CDConsole", "Play FAIL", SDL_GetError(), WARNING);
		else
			Gra_Debug("CDConsole", "Play DONE", "Reproduciendo", COMENTARIO);
	}
}

void CDConsole::Stop()
{
	if (estado == PLAY)
	{
		Gra_Debug("CDConsole", "Stop", "Detenido", COMENTARIO);
		estado = STOP;
	}
}
