/***************************************************************************
                          config_menu.cpp  -  description
                             -------------------
    begin                : Thu Feb 8 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "config_menu.h"

void LeerIdiomas(Option *);

void sldMusica::eventKeyUp(SDL_KeyboardEvent *e)
{
	Slider::eventKeyUp(e);
	Gra_VolumenMp3(musica, actual);
}

void sldMusica::eventMouseUp(SDL_MouseButtonEvent *e)
{
	Slider::eventMouseUp(e);
	Gra_VolumenMp3(musica, actual);
}

void sldMusica::setMusica(char *s)
{
	musica = Gra_LoadMp3(s);
}

void sldMusica::setFocus()
{
	Gra_PlayMp3(musica);
	Gra_VolumenMp3(musica, actual);
}

void sldMusica::lostFocus()
{
	Gra_StopMp3(musica);
}

void sldSonido::eventKeyUp(SDL_KeyboardEvent *e)
{
	Slider::eventKeyUp(e);
	Gra_VolumenWav(sonido, actual);
}

void sldSonido::eventMouseUp(SDL_MouseButtonEvent *e)
{
	Slider::eventMouseUp(e);
	Gra_VolumenWav(sonido, actual);
}

void sldSonido::setSonido(char *s)
{
	sonido = Gra_LoadWav(s);
}

void sldSonido::setFocus()
{
	Gra_VolumenWav(sonido, actual);
	Gra_PlayWav(sonido);
}

void sldSonido::lostFocus()
{
	Gra_StopWav(sonido);
}

void optIdioma::receiveMessage(FormObj *o, int cod)
{
	/* Busco el archivo de idioma seleccionado */
	FILE *fp;
	char tmp[255];
	int nada;

	/* Ignoro si es el mismo */
	if (strcmp(Gra_Idioma_Name(), *(opciones.At(activo))) == 0) {
		Gra_Debug("Engine Idioma", "Nuevo Idioma", "Ignorando", COMENTARIO);
		return;
	}
	
#ifdef LINUX
	DIR *dir;
	struct dirent *file;
	dir = opendir("Idioma");
	while ((file=readdir(dir)) != NULL) {
		if (strstr(file->d_name, ".idm")) {
			/* Leo el nombre del idioma del archivo */
			sprintf(tmp, "Idioma/%s", file->d_name);
			fp = fopen(tmp, "r");
			fscanf(fp, "%d\n", &nada);
			fscanf(fp, "%[^\n]", tmp);
			fclose(fp);
			if (strcmp(tmp, *(opciones.At(activo))) == 0) {
				sprintf(tmp, "Idioma/%s", file->d_name);
				break; /* salgo del while */
			}
		}
	}
	closedir(dir);
#endif
#ifdef WIN32
	_finddata_t data;
	long dir;
	dir = _findfirst("Mapas/*.*", &data);
	total = 0;
	if (data.attrib & _A_SUBDIR) {
		if (data.name[0] != '.') {
			nombres[total] = new char[strlen(data.name)+1];
			strcpy(nombres[total++], data.name);
		}
	}
	while (_findnext(dir, &data) == 0) {
		if ((data.attrib & _A_SUBDIR) && (data.name[0] != '.')) {
			nombres[total] = new char[strlen(data.name)+1];
			strcpy(nombres[total++], data.name);
		}
	}
	_findclose(dir);
#endif
	
	/* libero el idioma seleccionado */
	Gra_Idioma_Free();
	Gra_Idioma_Init(tmp);
}

void Configurar() {
	int v_mus, v_son, i, j;
	bool done=false;
	t_Volumen estado;
	Form *form;
	sldMusica *vol_musica;
	sldSonido *vol_sonido;
	Button *ok, *cancel, *idm_apply;
	CheckBox *vol_state, *use_cd;
	Label *lblmusica, *lblsonido;
	KeySelect *k_left[2], *k_right[2], *k_top[2], *k_down[2], *k_fire1[2], *k_fire2[2];
	Label *lk_left[2], *lk_right[2], *lk_top[2], *lk_down[2], *lk_fire1[2], *lk_fire2[2];
	NoteBook *note1;
	Tab *tplayer1, *tplayer2, *tsonido, *tidioma;
	Option *tipo_mando[2];
	optIdioma *opt_Idioma;
	Label *ltipo_mando[2], *lidioma;
	SDLKey up[2], down[2], left[2], right[2], fire1[2], fire2[2];
	int tipo[2];
	
	Gra_getVolumen(&v_son, &v_mus);
	for(i=0; i<2; i++)
		Gra_getKeys(i, &tipo[i], &up[i], &down[i], &left[i], &right[i], &fire1[i], &fire2[i]);
	estado = Gra_getVolumenState();

	form = new Form( &DrawOption );
	
	lblmusica = new Label(form, 60, 170, FONT_TIMES, Gra_Idioma_Get(22));
	vol_musica = new sldMusica(form, 60, 190, 200, 20, 128);
	vol_musica->setValue(v_mus);
	vol_musica->setMusica("sound/music/level01.mp3");
	
	lblsonido = new Label(form,60, 220, FONT_TIMES, Gra_Idioma_Get(23));
	vol_sonido = new sldSonido(form, 60, 240, 200, 20, 128);
	vol_sonido->setValue(v_son);
	vol_sonido->setSonido("sound/efectos/phaser.wav");

	vol_state = new CheckBox(form, 60, 270, FONT_TIMES, Gra_Idioma_Get(24), estado);
	
	use_cd = new CheckBox(form, 60, 275+vol_state->height(), FONT_TIMES, Gra_Idioma_Get(25), false);
	if (v_mus == -1)
		use_cd->Value(true);

	tsonido = new Tab(Gra_Idioma_Get(26));
	tplayer1 = new Tab(Gra_Idioma_Get(27));
	tplayer2 = new Tab(Gra_Idioma_Get(28));
	tidioma = new Tab(Gra_Idioma_Get(40));
	
	note1 = new NoteBook(form, 50, 140, 540, 190);
	note1->addTab(tsonido);
	note1->addTab(tplayer1);
	note1->addTab(tplayer2);
	note1->addTab(tidioma);

	lidioma = new Label(form, 60, 160, FONT_TIMES, Gra_Idioma_Get(40));
	opt_Idioma = new optIdioma(form, 80, 180, FONT_TIMES);
	idm_apply = new Button(form, 500, 300, FONT_TIMES, Gra_Idioma_Get(41));
	idm_apply->connect(opt_Idioma, FormObj::CLICKED_EVENT);
	LeerIdiomas(opt_Idioma);

	for(i=0; i<2; i++) {
		lk_top[i] = new Label(form, 380, 160, FONT_TIMES, Gra_Idioma_Get(29));
		k_top[i] = new KeySelect(form, 380, 180, 100, 20, FONT_TIMES);
		k_top[i]->setValue(up[i]);
	
		lk_left[i] = new Label(form, 280, 200, FONT_TIMES, Gra_Idioma_Get(30));
		k_left[i] = new KeySelect(form, 280, 220, 100, 20, FONT_TIMES);
		k_left[i]->setValue(left[i]);
		
		lk_right[i] = new Label(form, 480, 200, FONT_TIMES, Gra_Idioma_Get(31));
		k_right[i] = new KeySelect(form, 480, 220, 100, 20, FONT_TIMES);
		k_right[i]->setValue(right[i]);
		
		lk_down[i] = new Label(form, 380, 240, FONT_TIMES, Gra_Idioma_Get(32));
		k_down[i] = new KeySelect(form, 380, 260, 100, 20, FONT_TIMES);
		k_down[i]->setValue(down[i]);
		
		lk_fire1[i] = new Label(form, 280, 280, FONT_TIMES, Gra_Idioma_Get(33));
		k_fire1[i] = new KeySelect(form, 280, 300, 100, 20, FONT_TIMES);
		k_fire1[i]->setValue(fire1[i]);
		
		lk_fire2[i] = new Label(form, 480, 280, FONT_TIMES, Gra_Idioma_Get(34));
		k_fire2[i] = new KeySelect(form, 480, 300, 100, 20, FONT_TIMES);
		k_fire2[i]->setValue(fire2[i]);
		
		ltipo_mando[i] = new Label(form, 60, 170, FONT_COMIC, Gra_Idioma_Get(35));
		tipo_mando[i] = new Option(form, 60, 172+ltipo_mando[i]->height(), FONT_TIMES);
		tipo_mando[i]->addOption(Gra_Idioma_Get(36));

		for(j=0; j<SDL_NumJoysticks(); j++) {
			tipo_mando[i]->addOption((char *)SDL_JoystickName(j));
		}
		tipo_mando[i]->Value(tipo[i]+1);
	}
	
	/* Conecto para que se avisen si hay tecla repetida */
	for(i=0; i<2; i++)
		for(j=0; j<2; j++) {
			k_top[i]->connect(k_down[j], FormObj::KEY_VERIFY);
			k_top[i]->connect(k_left[j], FormObj::KEY_VERIFY);
			k_top[i]->connect(k_right[j], FormObj::KEY_VERIFY);
			k_top[i]->connect(k_fire1[j], FormObj::KEY_VERIFY);
			k_top[i]->connect(k_fire2[j], FormObj::KEY_VERIFY);
		
			k_down[i]->connect(k_top[j], FormObj::KEY_VERIFY);
			k_down[i]->connect(k_left[j], FormObj::KEY_VERIFY);
			k_down[i]->connect(k_right[j], FormObj::KEY_VERIFY);
			k_down[i]->connect(k_fire1[j], FormObj::KEY_VERIFY);
			k_down[i]->connect(k_fire2[j], FormObj::KEY_VERIFY);
		
			k_left[i]->connect(k_top[j], FormObj::KEY_VERIFY);
			k_left[i]->connect(k_down[j], FormObj::KEY_VERIFY);
			k_left[i]->connect(k_right[j], FormObj::KEY_VERIFY);
			k_left[i]->connect(k_fire1[j], FormObj::KEY_VERIFY);
			k_left[i]->connect(k_fire2[j], FormObj::KEY_VERIFY);
		
			k_right[i]->connect(k_top[j], FormObj::KEY_VERIFY);
			k_right[i]->connect(k_down[j], FormObj::KEY_VERIFY);
			k_right[i]->connect(k_left[j], FormObj::KEY_VERIFY);
			k_right[i]->connect(k_fire1[j], FormObj::KEY_VERIFY);
			k_right[i]->connect(k_fire2[j], FormObj::KEY_VERIFY);
		
			k_fire1[i]->connect(k_top[j], FormObj::KEY_VERIFY);
			k_fire1[i]->connect(k_down[j], FormObj::KEY_VERIFY);
			k_fire1[i]->connect(k_left[j], FormObj::KEY_VERIFY);
			k_fire1[i]->connect(k_right[j], FormObj::KEY_VERIFY);
			k_fire1[i]->connect(k_fire2[j], FormObj::KEY_VERIFY);
		
			k_fire2[i]->connect(k_top[j], FormObj::KEY_VERIFY);
			k_fire2[i]->connect(k_down[j], FormObj::KEY_VERIFY);
			k_fire2[i]->connect(k_left[j], FormObj::KEY_VERIFY);
			k_fire2[i]->connect(k_fire1[j], FormObj::KEY_VERIFY);
			k_fire2[i]->connect(k_right[j], FormObj::KEY_VERIFY);
		}
	k_top[0]->connect(k_top[1], FormObj::KEY_VERIFY);
	k_top[1]->connect(k_top[0], FormObj::KEY_VERIFY);
	k_down[0]->connect(k_down[1], FormObj::KEY_VERIFY);
	k_down[1]->connect(k_down[0], FormObj::KEY_VERIFY);
	k_left[0]->connect(k_left[1], FormObj::KEY_VERIFY);
	k_left[1]->connect(k_left[0], FormObj::KEY_VERIFY);
	k_right[0]->connect(k_right[1], FormObj::KEY_VERIFY);
	k_right[1]->connect(k_right[0], FormObj::KEY_VERIFY);
	k_fire1[0]->connect(k_fire1[1], FormObj::KEY_VERIFY);
	k_fire1[1]->connect(k_fire1[0], FormObj::KEY_VERIFY);
	k_fire2[0]->connect(k_fire2[1], FormObj::KEY_VERIFY);
	k_fire2[1]->connect(k_fire2[0], FormObj::KEY_VERIFY);

	/* Listo, ahora no pueden seleccionar 2 veces la misma tecla :-) */

	/* Agrego a los tabs */
	tsonido->addObject(lblmusica);
	tsonido->addObject(vol_musica);
	tsonido->addObject(lblsonido);
	tsonido->addObject(vol_sonido);
	tsonido->addObject(vol_state);
	tsonido->addObject(use_cd);
	tsonido->Visible(true);

	tplayer1->addObject(k_top[0]);
	tplayer1->addObject(k_left[0]);
	tplayer1->addObject(k_down[0]);
	tplayer1->addObject(k_right[0]);
	tplayer1->addObject(k_fire1[0]);
	tplayer1->addObject(k_fire2[0]);
	tplayer1->addObject(lk_top[0]);
	tplayer1->addObject(lk_left[0]);
	tplayer1->addObject(lk_down[0]);
	tplayer1->addObject(lk_right[0]);
	tplayer1->addObject(lk_fire1[0]);
	tplayer1->addObject(lk_fire2[0]);
	tplayer1->addObject(ltipo_mando[0]);
	tplayer1->addObject(tipo_mando[0]);
	tplayer1->Visible(false);

	tplayer2->addObject(k_top[1]);
	tplayer2->addObject(k_left[1]);
	tplayer2->addObject(k_down[1]);
	tplayer2->addObject(k_right[1]);
	tplayer2->addObject(k_fire1[1]);
	tplayer2->addObject(k_fire2[1]);
	tplayer2->addObject(lk_top[1]);
	tplayer2->addObject(lk_left[1]);
	tplayer2->addObject(lk_down[1]);
	tplayer2->addObject(lk_right[1]);
	tplayer2->addObject(lk_fire1[1]);
	tplayer2->addObject(lk_fire2[1]);
	tplayer2->addObject(ltipo_mando[1]);
	tplayer2->addObject(tipo_mando[1]);
	tplayer2->Visible(false);

	tidioma->addObject(lidioma);
	tidioma->addObject(opt_Idioma);
	tidioma->addObject(idm_apply);
	tidioma->Visible(false);

	ok = new Button(form, 50, 340, FONT_TIMES, Gra_Idioma_Get(11), Form::OK);
	cancel = new Button(form, 520, 340, FONT_TIMES, Gra_Idioma_Get(12), Form::CANCEL);

	form->setFocus(ok);
	bool faltan_teclas;
	while (!done) {
		if (form->Go() == Form::OK) {
			/* Valido que no falte ninguna tecla de mando */
			faltan_teclas = false;
			for(i=0; i<2; i++) {
				if ((k_top[i]->Value() == SDLK_UNKNOWN) || (k_down[i]->Value() == SDLK_UNKNOWN)
					|| (k_left[i]->Value() == SDLK_UNKNOWN) || (k_right[i]->Value() == SDLK_UNKNOWN)
					|| (k_fire1[i]->Value() == SDLK_UNKNOWN) || (k_fire2[i]->Value() == SDLK_UNKNOWN))
					faltan_teclas = true;
			}
			if (faltan_teclas) {
				ConfirmDialog(Gra_Idioma_Get(37), NULL, Gra_Idioma_Get(11));
				continue;
			}
			/* Verifico que 2 no tengan el mismo control (excepto teclado!) */
			if ((tipo_mando[0]->Value() == tipo_mando[1]->Value()) && (tipo_mando[0]->Value() != 0)) {
				ConfirmDialog(Gra_Idioma_Get(38), NULL, Gra_Idioma_Get(11));
				continue;
			}
			/* Salvo los parmetros */
			if (use_cd->Value())
				Gra_setVolumen(vol_sonido->Value(), -1);
			else
				Gra_setVolumen(vol_sonido->Value(), vol_musica->Value());
			for(i=0; i<2; i++)
				Gra_setKeys(i, tipo_mando[i]->Value()-1, k_top[i]->Value(), k_down[i]->Value(), k_left[i]->Value(), k_right[i]->Value(), k_fire1[i]->Value(), k_fire2[i]->Value());
			Gra_setVolumenState((vol_state)?VOLUMEN_ON:VOLUMEN_OFF);
			Gra_Flush();
			done = true;
		} else done = true;
	}
	
	delete form;
}

void LeerIdiomas(Option *o)
{
	FILE *fp;
	char tmp[255];
	int nada;
#ifdef LINUX
	DIR *dir;
	struct dirent *file;
	dir = opendir("Idioma");
	while ((file=readdir(dir)) != NULL) {
		if (strstr(file->d_name, ".idm")) {
			/* Leo el nombre del idioma del archivo */
			sprintf(tmp, "Idioma/%s", file->d_name);
			fp = fopen(tmp, "r");
			fscanf(fp, "%d\n", &nada);
			fscanf(fp, "%[^\n]", tmp);
			fclose(fp);
			/* Lo agrego como opcion */
			o->addOption(tmp);
		}
	}
	closedir(dir);
#endif
#ifdef WIN32
	_finddata_t data;
	long dir;
	dir = _findfirst("Mapas/*.*", &data);
	total = 0;
	if (data.attrib & _A_SUBDIR) {
		if (data.name[0] != '.') {
			nombres[total] = new char[strlen(data.name)+1];
			strcpy(nombres[total++], data.name);
		}
	}
	while (_findnext(dir, &data) == 0) {
		if ((data.attrib & _A_SUBDIR) && (data.name[0] != '.')) {
			nombres[total] = new char[strlen(data.name)+1];
			strcpy(nombres[total++], data.name);
		}
	}
	_findclose(dir);
#endif
}