/***************************************************************************
                          energybar.cpp  -  description
                             -------------------
    begin                : Sun Feb 25 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "energybar.h"

EnergyBar::EnergyBar(int max, int o, Uint32 color, Uint8 _alpha)
{
	maximo = max;
	actual = max;
	blanco = Gra_GetColor(0xFF, 0xFF, 0xFF);
	rojo = color;
	alpha= _alpha;
	orientacion = o;
	print_text = false;
	img = -1;
	draw_box = true;
}

EnergyBar::~EnergyBar()
{
}

void EnergyBar::setValor(int nuevo)
{
	actual = nuevo;
	if (actual<0) actual = 0;
	if (actual>maximo) actual = maximo;
}

void EnergyBar::Dibujar(SDL_Rect r)
{
	int x, y, llenar;
	/* ahora lleno el interior */
	switch (orientacion)
	{
		case(BAR_HORIZONTAL):
			llenar = actual * (r.w-1) / maximo;
			if (img == -1) {
				Gra_Lock();
			
				for(x=r.x+1; x<=r.x+llenar; x++)
					for(y=r.y+1; y<=r.y+r.h-1; y++)
						Gra_SetPixelA(x, y, rojo, alpha);

				Gra_Unlock();
			} else {
				/* Pongo textura de fondo */
				/* Supongo textura igual tamao que barra !!! */
				SDL_Rect tex, dst;
				tex.x = 0;
				tex.w = llenar;
				tex.y = 0;
				tex.h = r.h;
				dst.x = r.x;
				dst.y = r.y;;
				dst.w = llenar;
				dst.h = r.h;
				Gra_BlitImagen(img, &tex, &dst);
			}
			if (draw_box)
				Gra_DrawBox(r.x, r.y, r.w, r.h, blanco);
			break;
		case(BAR_VERTICAL):
			llenar = int ((r.h) * (actual / (float)maximo));
			if (img == -1) {
				Gra_Lock();
				for(y=r.y+1+((r.h-1) - llenar); y<=r.y+r.h-1; y++)
					for(x=r.x+1; x<=r.x+r.w-1; x++)
						Gra_SetPixelA(x, y, rojo, alpha);	
				if (draw_box)
					Gra_DrawBox(r.x, r.y, r.w, r.h, blanco);
				Gra_Unlock();
			} else {
				/* Pongo textura de fondo */
				/* Supongo textura igual tamao que barra !!! */
				SDL_Rect tex, dst;
				tex.x = 0;
				tex.w = r.w;
				tex.y = (r.h-llenar);
				tex.h = llenar;
				dst.x = r.x;
				dst.y = r.y + tex.y;
				dst.w = r.w;
				dst.h = r.h;
				Gra_BlitImagen(img, &tex, &dst);
				Gra_Lock();
				if (draw_box)
					Gra_DrawBox(r.x, r.y, r.w, r.h, blanco);
				Gra_Unlock();
			}
			break;
	}
	if (print_text) {
			switch (orientacion)
			{
				case(BAR_HORIZONTAL):
					Gra_Print(r.x+r.w/2, r.y+r.h/4, FONT_LCD, NULL, -1, false, "%3.0f %%", (float)(actual*100.00/(float)maximo));
					break;
				case(BAR_VERTICAL):
					break;
			}
	}
}

void EnergyBar::setTexture(char *c)
{
	if (c != NULL) {
		img = Gra_LoadImage(c, true);
	} else
		img = -1;
}
