/***************************************************************************
                          formobj.cpp  -  description
                             -------------------
    begin                : Sat Feb 24 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "formobj.h"

FormObj::FormObj(Form *_parent)
{
	parent = _parent;
	can_focus = true;
	parent->addObject(this);
	visible = true;
}

FormObj::~FormObj()
{
	objConected *tmp;
	while ((tmp=conectados.First())) {
		delete tmp;
		conectados.Delete();
	}
}

void FormObj::connect(FormObj *o, int code)
{
	conectados.Append( new objConected(o, code) );
}

void FormObj::disconnect(FormObj *o)
{
	objConected *tmp;
	for(tmp=conectados.First(); tmp->_obj != o; tmp=conectados.Next()) {}
	
	if (tmp!=NULL)
		conectados.Delete();
}

void FormObj::sendMessage(int code)
{
	objConected *tmp;
	for(tmp=conectados.First(); tmp; tmp=conectados.Next()) {
		if (tmp->_code == code) {
			(tmp->_obj)->receiveMessage(this, code);
		}
	}
}

bool FormObj::isMouseOver(int x, int y)
{
	if ((x>r.x) && (x<(r.x+r.w)) && (y>r.y) && (y<(r.y+r.h)))
		return true;
	return false;
}

