/***************************************************************************
                          glist.h  -  description
                             -------------------
    begin                : Sun Jul 30 2000
    copyright            : (C) 2000 by Ricardo Markiewicz
    email                : gazer@linuxzone.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GLIST_H
#define GLIST_H

#include <stdio.h>
#include <stdlib.h>

/**Clase Generica para manejo de listas doblemente enlazadas
  *@author Ricardo Markiewicz
  */

/* clase de los nodos de la lista */
class LstNodo {
friend class GList;
public:
	typedef void *Item;
	Item getData() { return data; }
private:
	LstNodo( Item d ) { data=d; }
	Item data;
	LstNodo *next;
	LstNodo *prev;
};

/* lista generica */
class GList {
public: 
	GList();
	~GList();
	bool Insert(int, LstNodo::Item);
	bool Insert(LstNodo::Item);
	bool Append(LstNodo::Item);
	bool Delete(int);
	bool DeleteFirst();
	bool DeleteLast();
	bool Delete();
	LstNodo *Localizar(unsigned int);
	LstNodo::Item Current();
	LstNodo::Item First();
	LstNodo::Item Last();
	LstNodo::Item Next();
	LstNodo::Item Prev();
	LstNodo::Item At(unsigned int);
	int Count() { return numNodos; }
	int Find(LstNodo::Item);
	int CurrentIndex() { return Find(current); }
private:
	LstNodo *first;
	LstNodo *current;
	LstNodo *last;
	int numNodos;
};

#endif
