/***************************************************************************
                          keyselect.cpp  -  description                             -------------------
    begin                : Sat Feb 24 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "keyselect.h"

KeySelect::KeySelect(Form *p, int x, int y, int w, int h, int font):FormObj(p)
{
	r.x = x;
	r.y = y;
	r.w = w;
	r.h = h;
	fuente = font;
	key_name[0] = ' ';
	key_name[1] = '\0';
}

KeySelect::~KeySelect()
{
}

void KeySelect::Dibujar(bool focus)
{
	SDL_Color *normal;
	if (focus)
		normal = &parent->text_focus;
	else
		normal = &parent->text_normal;

	if (focus)
		Gra_DrawBox3D(r.x, r.y, r.w, r.h, 0, Gra_GetColor(0xff, 0, 0), true);
	else
		Gra_DrawBox3D(r.x, r.y, r.w, r.h, 0, parent->text_background, true);
	/* tengo que pones que imprima la tecla ... */
	switch (key) {
		case (SDLK_a):
		case (SDLK_b):
		case (SDLK_c):
		case (SDLK_d):
		case (SDLK_e):
		case (SDLK_f):
		case (SDLK_g):
		case (SDLK_h):
		case (SDLK_i):
		case (SDLK_j):
		case (SDLK_k):
		case (SDLK_l):
		case (SDLK_m):
		case (SDLK_n):
		case (SDLK_o):
		case (SDLK_p):
		case (SDLK_q):
		case (SDLK_r):
		case (SDLK_s):
		case (SDLK_t):
		case (SDLK_u):
		case (SDLK_v):
		case (SDLK_w):
		case (SDLK_x):
		case (SDLK_y):
		case (SDLK_z):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, key_name);
		break;
		case (SDLK_LEFT):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "Left");
		break;
		case (SDLK_RIGHT):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "Right");
		break;
		case (SDLK_UP):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "Up");
		break;
		case (SDLK_DOWN):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "Down");
		break;
		case (SDLK_INSERT):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "Insert");
		break;
		case (SDLK_DELETE):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "Delete");
		break;
		case (SDLK_HOME):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "Home");
		break;
		case (SDLK_END):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "End");
		break;
		case (SDLK_SPACE):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "Space");
		break;
		case (SDLK_RETURN):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "Enter");
		break;
		case (SDLK_KP0):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "Keypad 1");
		break;
		case (SDLK_KP1):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "Keypad 1");
		break;
		case (SDLK_KP2):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "Keypad 2");
		break;
		case (SDLK_KP3):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "Keypad 3");
		break;
		case (SDLK_KP4):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "Keypad 4");
		break;
		case (SDLK_KP5):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "Keypad 5");
		break;
		case (SDLK_KP6):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "Keypad 6");
		break;
		case (SDLK_KP7):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "Keypad 7");
		break;
		case (SDLK_KP8):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "Keypad 8");
		break;
		case (SDLK_KP9):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, "Keypad 9");
		break;
		case (SDLK_UNKNOWN):
			Gra_Print(r.x+3, r.y+1, fuente, normal, -1, false, Gra_Idioma_Get(39));
	}
}

void KeySelect::setFocus()
{
}

void KeySelect::eventKeyUp(SDL_KeyboardEvent *e)
{
	switch (e->keysym.sym) {
		case (SDLK_a):
		case (SDLK_b):
		case (SDLK_c):
		case (SDLK_d):
		case (SDLK_e):
		case (SDLK_f):
		case (SDLK_g):
		case (SDLK_h):
		case (SDLK_i):
		case (SDLK_j):
		case (SDLK_k):
		case (SDLK_l):
		case (SDLK_m):
		case (SDLK_n):
		case (SDLK_o):
		case (SDLK_p):
		case (SDLK_q):
		case (SDLK_r):
		case (SDLK_s):
		case (SDLK_t):
		case (SDLK_u):
		case (SDLK_v):
		case (SDLK_w):
		case (SDLK_x):
		case (SDLK_y):
		case (SDLK_z):
			key_name[0] = e->keysym.sym;
		case (SDLK_LEFT):
		case (SDLK_RIGHT):
		case (SDLK_UP):
		case (SDLK_DOWN):
		case (SDLK_INSERT):
		case (SDLK_DELETE):
		case (SDLK_HOME):
		case (SDLK_END):
		case (SDLK_SPACE):
		case (SDLK_RETURN):
		case (SDLK_KP0):
		case (SDLK_KP1):
		case (SDLK_KP2):
		case (SDLK_KP3):
		case (SDLK_KP4):
		case (SDLK_KP5):
		case (SDLK_KP6):
		case (SDLK_KP7):
		case (SDLK_KP8):
		case (SDLK_KP9):
			key = e->keysym.sym;
			break;
		default:
			key = SDLK_UNKNOWN;
	}
	sendMessage(KEY_VERIFY);
}

void KeySelect::receiveMessage(FormObj *o, int cod)
{
	if (cod == KEY_VERIFY) { /* Verifico que no usen mi tecla */
		KeySelect *tmp = (KeySelect *)o;
		if (key == tmp->Value()) /* usa mi tecla !! */
			key = SDLK_UNKNOWN;
	}
}
