/***************************************************************************
                          matematica.cpp  -  description
                             -------------------
    begin                : Wed Feb 7 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "matematica.h"

Punto2D::Punto2D()
{
	x = y = 0;
}

Punto2D::Punto2D(float _x, float _y)
{
	x = _x;
	y = _y;
}

Punto2D::~Punto2D()
{
}

void Punto2D::operator += (Punto2D o)
{
	x += o.X();
	y += o.Y();
}

void Punto2D::operator -= (Punto2D o)
{
	x -= o.X();
	y -= o.Y();
}

bool Punto2D::operator == (Punto2D o)
{
	return ((x == o.X()) && (y == o.Y()));
}

bool Punto2D::operator != (Punto2D o)
{
	return ((x != o.X()) && (y != o.Y()));
}

Punto2D Punto2D::operator + (Punto2D o)
{
	Punto2D tmp;
	tmp.setX(x + o.X());
	tmp.setY(y + o.Y());
	return tmp;
}

Punto2D Punto2D::operator - (Punto2D o)
{
	Punto2D tmp;
	tmp.setX(x - o.X());
	tmp.setY(y - o.Y());
	return tmp;
}

void Punto2D::operator = (Punto2D o)
{
	x = o.X();
	y = o.Y();
}

SDL_Rect Punto2D::toRect(float w, float h)
{
	SDL_Rect tmp;
	tmp.x = (Sint16)x;
	tmp.y = (Sint16)y;
	tmp.w = (Uint16)w;
	tmp.h = (Uint16)h;
	return tmp;
}

void Punto2D::operator *= (float i)
{
	x *= i;
	y *= i;
}

void Punto2D::operator /= (float i)
{
	x /= i;
	y /= i;
}

Punto2D Punto2D::operator * (float f)
{
	Punto2D tmp;
	tmp.setX( x * f);
	tmp.setY( y * f);
	return tmp;
}

float Punto2D::dist(Punto2D o)
{
	o -= *(this);
	return sqrt( o.X()*o.X() + o.Y()*o.Y() );
}

Punto2D Punto2D::getDir(Punto2D o)
{
	o -= *(this);
	o /= o.Norma();
	return o;
}