/***************************************************************************
                          new_pilot.cpp  -  description
                             -------------------
    begin                : mi feb  7 01:50:28 ART 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "new_pilot..h"

extern void DrawOption(void);

void DisparoPic::receiveMessage(FormObj *o, int cod)
{
	Selector *selector = (Selector *)o;
	
	switch (selector->Value())
	{
		case (FERNY):
			cod_img = Gra_LoadImage("Naves/Ferny/shot_preview.png");
		break;
		case (JORGE):
			cod_img = Gra_LoadImage("Naves/Jorge/shot_preview.png");
		break;
		case (SAGAR):
			cod_img = Gra_LoadImage("Naves/Sagar/shot_preview.png");
		break;
		case (RICKY):
		case (JUANE):
		case (ZAFFO):
			cod_img = Gra_LoadImage("Naves/Caza/shot_preview.png");
	}
}

int CreatePilot()
{
	Form *form;
	TextField *nombre;
	Selector *pil;
	Button *ok, *cancel;
	Label *l1, *l2, *lbldisparo;
	DisparoPic *disparo;
	
	form = new Form(&DrawOption);
	l1 = new Label(form, 50, 150, FONT_TIMES, Gra_Idioma_Get(20));
	nombre = new TextField(form, 50+l1->width(), 150, 150, 20, 15, FONT_TIMES);
	
	l2 = new Label(form, 350, 150, FONT_TIMES, Gra_Idioma_Get(21));
	pil = new Selector(form, 350, 150+l1->height(), 100, 100);
	pil->addPicture("pilotos/ferny.png");
	pil->addPicture("pilotos/jorge.png");
	pil->addPicture("pilotos/ricky.png");
	pil->addPicture("pilotos/juane.png");
	pil->addPicture("pilotos/sagar.png");
	pil->addPicture("pilotos/zaffo.png");
	
	lbldisparo = new Label(form, 50, 180, FONT_TIMES, Gra_Idioma_Get(42));

	disparo = new DisparoPic(form, 50, 200, 100, 100);
	pil->connect(disparo, FormObj::CHANGE_EVENT);

	ok = new Button(form, 50, 350, FONT_TIMES, Gra_Idioma_Get(11), Form::OK);
	cancel = new Button(form, 520, 350, FONT_TIMES, Gra_Idioma_Get(12), Form::CANCEL);

	switch (form->Go()) {
		case (Form::OK):
			SaveNewPilot(nombre->Value(), pil->Value());
		case (Form::CANCEL):
			break;
	}

	delete form;

	return 0;
}

void SaveNewPilot(char *c, int i)
{
	/* Pilotos(int vx, int vy, int sf, int si, int piloto, char *name); */
	Pilotos *p;
	switch (i) {
		case (FERNY):
			p = new Pilotos(4, 6, 0, 0, i, c);
		break;
		case (JORGE):
			p = new Pilotos(5, 5, 0, 0, i, c);
		break;
		case (SAGAR):
			p = new Pilotos(6, 6, 0, 0, i, c);
		break;
		case (RICKY):
		case (JUANE):
		case (ZAFFO):
			p = new Pilotos(4, 4, 0, 0, i, c);
	}

	lst_pil.Append(p);
}
