/***************************************************************************
                          niveles.h  -  description
                             -------------------
    begin                : Sat Feb 10 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NIVELES_H
#define NIVELES_H

#include <SDL.h>
#include "matematica.h"
#include "objetos.h"
#include "graficos_lib.h"
#include "constantes.h"
#include "energybar.h"

/**
  *@author Ricardo Markiewicz
  */
typedef int *t_Linea_Mapa;
typedef t_Linea_Mapa *Mapa;

typedef struct _lista_decora {
	int cod_decorado;
	SDL_Rect pos;
	struct _lista_decora *next;
} It_Decorado, *Decorados;
	
class Niveles {
public: 
	Niveles(int num, char *player1, char *player2=NULL);
	~Niveles();
	void Dibujar();
	void Mover();
	bool CanMoveX(Punto2D pos, Uint16 w);
	bool CanMoveY(Punto2D pos, Uint16 w);
	bool isScrolling();
	bool isInside(Objetos *obj);
	Punto2D ScreenPos(Punto2D pos);
	SDL_Rect ScreenPos(SDL_Rect pos);
	inline int Get_OffSide() { return pos_y; }
	char *getName() { return name; }
	inline bool isOk() { return carga_completa; }
private:
	char name[255];
	bool carga_completa;
	int pos_y; /* posicion de donde esta el mapa */
	int numero; /* numero del nivel */
	Mapa mapa;
	Lista<It_Decorado> decorados;
	int total_terrenos, total_decorados, total_lineas;
	SDL_Surface **terrenos_pics;
	SDL_Surface **decorados_pics;
	void Update(char *n, char *n1);
	int b_count, img;
	EnergyBar *barra;
	SDL_Rect r_bar;
};

#endif
