/***************************************************************************
                          objetos.h  -  description
                             -------------------
    begin                : Wed Feb 7 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef OBJETOS_H
#define OBJETOS_H

#include "matematica.h"

/**Esta es la clase base para todos los objetos.
Un objeto puede ser una nave, una torreta de misiles,
una casa que puede ser destruida, un "bonus" de
armas o vida. En fin, toda aquella cosa
que interactue con el jugador.
  *@author Ricardo Markiewicz
  */
class Niveles;
class Controlador;

class Objetos {
public: 
	Objetos(Niveles *niv, Controlador *c, int i=-1);
	virtual ~Objetos();
	virtual void Dibujar() = 0; /* despues veo sobre que dibujo */
	virtual void Mover() = 0;
	float RadioChoque() { return radio_choque; }
	inline Punto2D Pos() { return pos; }
	inline int getDamage() { return damage; }
	inline virtual void Daniar(int dam) { life -= dam; }
	inline virtual bool isAlive() { return (life > 0); }
	inline bool doExplosion() { return explode; }
	inline virtual int getPuntos() { return puntos; }
	void Player(int i) { num_player = i; }
	int Player() { return num_player; }
protected:
	Controlador *control;
	Niveles *current;
	Punto2D pos; /* la posicion indica donde esta en centro geom. en el escenario */
	Punto2D tam; /* tamao del objeto */
	int radio_choque; /* aproximacion para ver si chocan 2 objetos */
	int damage, life;
	bool explode;
	int puntos;
	int num_player;
};

#endif