/***************************************************************************
                          particulas.cpp  -  description
                             -------------------
    begin                : Sun Feb 25 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "particulas.h"
#include "controlador.h"
#include <stdlib.h>
#include <time.h>
#include <math.h>

Particulas::Particulas(Niveles *niv, Controlador *c, t_Part_Parametro *param):Objetos(niv, c, -1)
{
	/* inicializo el objeto */
	radio_choque = 0;
	nivel = niv;
	pos = param->pos;
	life = 255;
	dibuje = true;
	/* creo el array de particulas */
	total = param->cant;
	particulas = new t_Particula[total];
	damage = 0;
	/* ahora dependiendo del efecto inicio las particulas */
	switch (param->ef)
	{
		case (PARTICULA_LINEAL): // Hay que rehacer este modo !!!!!!!!!!
		{
			for(int i=0; i<total; i++)
			{
/*				particulas[i].pos = param->pos;
				particulas[i].vel = param->dir * (param->vel * param->random * ((float)rand() / (float)RAND_MAX));
				particulas[i].acel = Punto2D(0,0);
				particulas[i].color = param->inicio;
				particulas[i].life = param->life;*/
			}
			break;
		}
		case (PARTICULA_CIRCULAR):
		{
			float angulo=0;
			float ca, sa;
			for(int i=0; i<total; i++)
			{
				ca = cos(angulo);
				sa = sin(angulo);
				particulas[i].xpos =  (WIDTH >> 1) - 20 + (int)(40.0 * (rand()/(RAND_MAX+1.0)));
				particulas[i].ypos =  (WIDTH >> 1) - 20 + (int)(40.0 * (rand()/(RAND_MAX+1.0)));
				particulas[i].xdir =   -10 + (int)(20.0 * (rand()/(RAND_MAX+1.0)));
				particulas[i].ydir =   -17 + (int)(19.0 * (rand()/(RAND_MAX+1.0)));
				particulas[i].colorindex = 254; /* 255 == color transparente :-) */
				particulas[i].dead = 0;
			}
			break;
		}
	}

	control->AddObjetoBueno(this);

	/* Copio la paleta de colores */
	memcpy(paleta, param->colors, sizeof(Uint32)*256);
	
	memset(fire, 0, WIDTH * WIDTH * sizeof(Uint32));
}

Particulas::~Particulas()
{
	delete [] particulas;
}

void Particulas::Dibujar()
{
	Punto2D tmp;
  Uint32 buf, index, temp;
	int i, j;

	dibuje=false;
	/* si no estoy en pantalla no hago nada */

	if (!current->isInside(this)) return;

	/* Este codigo es una modificacin de uno GPL que lei por la Web (estoy buscando
	la URL para dar creditos al autor), con varias modificaciones propias para adaptarlo
	a mi engine */

	for (i = 0; i < total; i++) {
		if (!particulas[i].dead) {
			particulas[i].xpos += (Uint16)(particulas[i].xdir);//*Gra_SpeedFactor());
			particulas[i].ypos += (Uint16)(particulas[i].ydir);//*Gra_SpeedFactor());

			particulas[i].colorindex -= (Uint8)(5*Gra_SpeedFactor());

			/* La particula muere en el paleta[color] == 0 */
			if ((particulas[i].ypos >= WIDTH - 3) || particulas[i].colorindex < 50 || 
				particulas[i].xpos <= 1 || particulas[i].ypos <= 1|| particulas[i].xpos >= WIDTH - 3) {
					particulas[i].dead = 1;
					continue;
			}

			/* En este punto esta particula la voy a usar, asi que por lo menos
				tengo una particula ==> dibujo algo */
			dibuje = true;

			temp = particulas[i].ypos * WIDTH + particulas[i].xpos;

			fire[temp] = particulas[i].colorindex;
			fire[temp - 1] = particulas[i].colorindex;
			fire[temp + WIDTH] = particulas[i].colorindex;
			fire[temp - WIDTH] = particulas[i].colorindex;
			fire[temp + 1] = particulas[i].colorindex;
		}
	}

	/* Si no hay particulas vivas no tengo mas que hacer ... */
	if (dibuje == false) return;

	Punto2D s_pos = current->ScreenPos(pos);
	Gra_Lock();
	for (i = 1; i < WIDTH - 2; i++) {
		index = (i  - 1) * WIDTH;

		for (j = 1; j < WIDTH - 2; j++) {
			buf = index + j;

			temp = fire[buf];
			temp += fire[buf + 1];
			temp += fire[buf - 1];
			buf += WIDTH;
			temp += fire[buf - 1];
			temp += fire[buf + 1];
			buf += WIDTH;
			temp += fire[buf];
			temp += fire[buf + 1];
			temp += fire[buf - 1];

			temp >>= 3;

			if (temp > 4) {
				temp -= 4;
			} else {
				temp = 0;
			}

			fire[buf - WIDTH] = temp;
			if (fire[buf-WIDTH] > 50) /* Saco la parte negra de la explocion ... */
				Gra_SetPixel((int)(s_pos.X()+j-WIDTH/2), (int)(s_pos.Y()+i-WIDTH/2), paleta[temp]);
		}
	}
	Gra_Unlock();
}

void Particulas::Mover()
{
	/*
	Las particulas las muevo justo antes de dibujar, porque no me afecta en nada porque no chocan!
	
	De hacerlo aqui, primero muevo todas (un for), luego dibujo todas (otro for) lo que significa
	que si tengo 200 particulas, estoy laburando 2 for de 200, o sea uno de 400!! .. por cada
	explocion que tengo en pantalla ... muy lento y pierdo performance!!
	*/
}

bool Particulas::isAlive()
{
	return dibuje;
}
