/***************************************************************************
                          rocket.cpp  -  description
                             -------------------
    begin                : Sat Feb 24 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "rocket.h"
#include "controlador.h"
#include "niveles.h"

Rocket::Rocket(Punto2D inicio, Niveles *niv,  Controlador *control, int i):Objetos(niv, control, i)
{
	explode = false;
	pos = inicio;
	life = 9;
	count = 0;
	radio_choque = 20;
	damage = 9999999;
	imagen = Gra_LoadImage("Comunes/rocket.png", false);
	Gra_SetColorKey(imagen, 0xff, 0xff, 0xff);

	control->AddObjetoBueno(this);
}

Rocket::~Rocket()
{
	control->RocketDestroy(num_player);
}

void Rocket::Mover()
{
	Punto2D dest = control->getMasCercano(pos, true);
	Punto2D vel;
	if (dest != Punto2D(0,0))
	{
		vel = pos.getDir(dest);
		vel /= vel.Norma();
		vel *= 4;
	}
	else
		vel = Punto2D(0, -1);

	pos += vel*Gra_SpeedFactor();
}

void Rocket::Dibujar()
{
	float angulo;
	Punto2D tmp = current->ScreenPos(pos);
	Punto2D dest = control->getMasCercano(pos, true);
	if (dest == Punto2D(0,0))
		angulo = PI;
	else
	{
		Punto2D target = pos.getDir( dest );
		angulo = target.Angulo(Punto2D(0,1));
		if (pos.X() > dest.X())
			 angulo *= -1;
	}
	if (tmp.Y() > Gra_ScreenHeight())
		life = -1;

	Gra_BlitRotateImage(imagen, angulo, tmp, false, false);
}

void Rocket::Daniar(int dam)
{
	count--;
	if (count < 0)
		life = -1;
}