/***************************************************************************
                          scriptparser.h  -  description
                             -------------------
    begin                : Sun Mar 18 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SCRIPTPARSER_H
#define SCRIPTPARSER_H

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

/* tipos de Bloques de script */
typedef enum {TYPE_EVENT, TYPE_NORMAL} t_Evento;

typedef struct _t_script_block {
	char *line;
	struct _t_script_block *next;
} t_Script_Block;

typedef struct _t_script_file {
	t_Evento type;
	char *name;
	t_Script_Block *block;
	struct _t_script_file *next;
} t_Script_File;

/**
  *@author Ricardo Markiewicz
  */

class ScriptParser {
public: 
	ScriptParser();
	~ScriptParser();
	int CallEvent(int event);
	int LoadScript(char *filename);
private:
	t_Script_Block *readBlock(FILE *fp);
	void CmdIf(char *line);
	void CmdDo();
	void CmdFor();
	void CmdWhile();
	float variables[16];
	t_Script_File *script;
};

#endif
