/***************************************************************************
                          selector.cpp  -  description
                             -------------------
    begin                : Sat Feb 24 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "selector.h"

Selector::Selector(Form *p, int x, int y, int w, int h):FormObj(p)
{
	r.x = x;
	r.y = y;
	r.h = h;
	r.w = w;
}

Selector::~Selector()
{
	int *tmp;
	while ((tmp=imagenes.First())) {
		delete tmp;
		imagenes.Delete();
	}
}

void Selector::addPicture(const char *img)
{
	int *tmp, *tmp1;
	tmp = new int;
	*tmp = Gra_LoadImage((char *)img);
	if (*tmp != -1) {
		imagenes.Append(tmp);
		tmp1 = imagenes.First();
		indice = tmp1;
	}
	else
		delete tmp;
}

void Selector::Dibujar(bool focus)
{
	Gra_BlitImagen(*indice, NULL, &r);
	if (focus)
		Gra_DrawBox(r.x, r.y, r.w, r.h, Gra_GetColor(255, 255, 255), 0, false);
	else
		Gra_DrawBox3D(r.x, r.y, r.w, r.h, Gra_GetColor(128, 128, 128), 0, false);
}

void Selector::setFocus()
{
}

void Selector::eventKeyDown(SDL_KeyboardEvent *key)
{
}

void Selector::eventKeyUp(SDL_KeyboardEvent *key)
{
	switch (key->keysym.sym) {
		case (SDLK_ESCAPE):
			parent->Done();
		break;
		case (SDLK_TAB):
			parent->NextFocus(this);
		break;
		case (SDLK_LEFT):
			Prev();
		break;
		case (SDLK_RIGHT):
			Next();
		break;
	}
}

void Selector::eventMouseDown(SDL_MouseButtonEvent *e)
{
}

void Selector::eventMouseUp(SDL_MouseButtonEvent *e)
{
	if (!isMouseOver(e->x, e->y)) return;

	if (e->button == SDL_BUTTON_LEFT)
		Next();
	if (e->button == SDL_BUTTON_RIGHT)
		Prev();
}

void Selector::eventMouseMove(SDL_MouseMotionEvent *e)
{
}

void Selector::Next()
{
	int *tmp;
	tmp = imagenes.Next();
	if (tmp == NULL) {
		tmp = imagenes.First();
		indice = tmp;
	} else {
		indice = tmp;
	}						
	sendMessage(CHANGE_EVENT);
}

void Selector::Prev()
{
	int *tmp;
	tmp = imagenes.Prev();
	if (tmp == NULL) {
		tmp = imagenes.Last();
		indice = tmp;
	} else {
		indice = tmp;
	}						
	sendMessage(CHANGE_EVENT);
}
