/***************************************************************************
                          storreta.cpp  -  description
                             -------------------
    begin                : Sun Feb 25 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "storreta.h"

STorreta::STorreta(Punto2D pos_ini, Niveles *niv, Controlador *c):Objetos(niv,c,-1)
{
	img_cod = Gra_LoadImage("Estructuras/STorreta/storreta.png", true);
	snd_disparo = -1;
	pos = pos_ini;
	life = ENEMY_TORRETA_LIFE*2;
	damage = 150;
	radio_choque = Gra_GetImagenWidth(img_cod)/2;
	calentamiento = 0;
	explode = true;
	puntos = 150;
	control->AddObjetoMalo(this);
}

STorreta::~STorreta()
{
}

void STorreta::Dibujar()
{
	Punto2D tmp = current->ScreenPos(pos);

	Gra_BlitImagen(img_cod, NULL, tmp);
}

void STorreta::Daniar(int dam)
{
	life -= dam;
}

void STorreta::Mover()
{
	if (!current->isInside(this)) return;

	if (calentamiento == 0)
	{
		new IonCannon(Punto2D(pos.X(), pos.Y()-radio_choque), current, control, true, -1, Armas::GO_DOWN);
		new IonCannon(Punto2D(pos.X(), pos.Y()+radio_choque), current, control, true, -1, Armas::GO_UP);
		new IonCannon(Punto2D(pos.X()-radio_choque, pos.Y()), current, control, true, -1, Armas::GO_LEFT);
		new IonCannon(Punto2D(pos.X()+radio_choque, pos.Y()), current, control, true, -1, Armas::GO_RIGHT);
		new IonCannon(Punto2D(pos.X()+radio_choque, pos.Y()+radio_choque), current, control, true, -1, Armas::GO_RIGHTUP);
		new IonCannon(Punto2D(pos.X()-radio_choque, pos.Y()+radio_choque), current, control, true, -1, Armas::GO_LEFTUP);
		new IonCannon(Punto2D(pos.X()-radio_choque, pos.Y()-radio_choque), current, control, true, -1, Armas::GO_LEFTDOWN);
		new IonCannon(Punto2D(pos.X()+radio_choque, pos.Y()-radio_choque), current, control, true, -1, Armas::GO_RIGHTDOWN);
		calentamiento = 100;
	}
	else
		calentamiento--;
}
